/***************************************************************************/
// This can be used to generate a song list from HOTDOG20.DAT
// The language specific data yet to be completed.
//---------------------------------------------------------------------------
// 03/07/07     Updated
// Author: Phuoc Can HUA (02/07/07)
/***************************************************************************/

#include <stdio.h>
#include <ctype.h>

int	SongTotal= 0, TocOffset;

typedef struct
{		int	SongTotal, Offset;
} InputFileType;

typedef struct
{       char	Name, Id;
        int	Offset;
} LangType;

InputFileType	KnownFile[]=
{	30534, 0x25e0,
	30926, 0x2640
};
LangType	LangAll[]=
{	'C', 0x03, 0,           // Chinese (GB18030)
	'E', 0x12, 700001,      // English
        'F', 0x14, 0,           // Filipino
        'J', 0x04, 0,           // Japanese
	'K', 0x00, 0,           // Korean
        'S', 0x16, 0,           // Spainish
	'V', 0x13, 0,           // Vietnamese
        '5', 0x05, 0            // unknown
};

//==========================================================================
int     main( int argc, char *argv[])
{
char    C, *Filename;
unsigned char     LangId;
int     I,J,
        Len, SongNo;
FILE    *InFile;
LangType        *Lng;

if( argc!= 3)
{	printf("Usage: %s <filename> ", argv[0]);
		for( I= 0; I < sizeof( LangAll)/sizeof( LangType); I++)
        {       if(I)
                        printf("|");
                printf("%c", LangAll[I].Name);
		}
        printf("\n");
        return 0;
}
Filename= argv[1];
LangId= argv[2][0];
Lng= NULL;
for( I= 0; I < sizeof( LangAll)/sizeof( LangType); I++)
        if( LangAll[I].Name== LangId)
        {       Lng= &LangAll[I];
                break;
        }
if( Lng== NULL)
{       printf("Unknown language %c\n", LangId);
        return 1;
}

InFile= fopen( Filename, "rb");
for( I= 0; I< 4; I++)
        SongTotal= (SongTotal << 8)+(int)getc( InFile);

TocOffset= -1;
for( I= 0; I< sizeof( KnownFile)/sizeof( InputFileType); I++)
        if( SongTotal== KnownFile[I].SongTotal)
        {	TocOffset= KnownFile[I].Offset;
                break;
        }
if( TocOffset < 0)
{       printf("%s unknow file\n", Filename);
        fclose( InFile);
        return 1;
}

printf("%d songs (%c), read from 0x%06x\n", SongTotal, Lng->Name, TocOffset);
fseek( InFile, TocOffset , SEEK_SET);
for( I= 0; I< SongTotal; I++ )
{	Len= getc( InFile);
        LangId= getc( InFile);
        if( LangId!= Lng->Id)// && 0)
        {       fseek( InFile, Len-2, SEEK_CUR);
                continue;
        }
        SongNo= getc( InFile);
        SongNo=(SongNo << 8)+getc( InFile);
        printf("%6d ", Lng->Offset+ SongNo);
//        printf("0x%02x ", LangId);
        for( J= 0; J< Len-4; J++)
        {	C= getc( InFile);
                printf("%c", C);
        }
        printf("\n");
}

fclose( InFile);
return 0;
}


